/*****************************************************************************
*                           JMatLink                                         *
******************************************************************************
* (c) 1999 Stefan Mueller                                                    *
******************************************************************************
* 19.01.1999  beginning (reuse of HelloWorld example, Java Tutorial)  (0.01) *
* 06.02.1999  separation from gui                                     (0.02) *
* 27.03.1999  engGetScalar, engGetVector, engGetArray                 (0.03) *
*             engGetScalar already working                                   *
* 01.04.1999  engGetArray: hints from bwymans@home.com                       *
* 02.05.1999  engGetArray is working now                              (0.04) *
* 20.05.1999  begin of engPutArray                                           *
* 13.08.1999  renamed all native methods to ...NATIVE                 (0.05) *
* 30.08.1999  beginning to include some failure checks                (0.06) *
* 31.08.1999  increased BUFSIZE to account for larger outputs         (0.07) *
* 11.09.1999  get char arrays from workspace                          (0.08) *
* 10.10.1999  engPutArray[][] completed                               (0.10) *
******************************************************************************/


/* **** ToDo ****
*  complex number support
*
*/


#include <jni.h>
#include "JMatLink.h"
#include <stdio.h>


#include <stdlib.h>
#include <string.h>
#include "engine.h"

#define  BUFSIZE 2560

   Engine *ep;
   mxArray *T      = NULL;
   mxArray *result = NULL;
   char buffer[BUFSIZE];
   double time[10] = { 0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0 };
   double *TP;
   mxArray  *arrayP;
   jdouble  scalar;
   int      OpenB = 0;

 
// public native void   engOpenNATIVE();
JNIEXPORT void JNICALL Java_JMatLink_engOpenNATIVE  (JNIEnv *env, jobject obj){
        if (OpenB==1) {
           printf("engine already open");
           return;
        }
	if (!(ep = engOpen("\0"))) {
		fprintf(stderr, "\nCan't start MATLAB engine\n");
		return;
	} 
        else { 
           engOutputBuffer(ep, buffer, BUFSIZE);
           fprintf(stderr, "\nengine open\n");
           OpenB=1;
        }

}

// public native void   engCloseNATIVE();
JNIEXPORT void JNICALL Java_JMatLink_engCloseNATIVE  (JNIEnv *env, jobject obj){
   if ( OpenB ==1 ){
      engClose(ep);
      OpenB=0;
      printf("\n engClose \n");
   }
   else {
      printf("\n engine already closed %i",OpenB);
   }

}

//
// public native void   engEvalStringNATIVE(String evalS);
//
JNIEXPORT void JNICALL Java_JMatLink_engEvalStringNATIVE  (JNIEnv *env, jobject obj, jstring evalS_JNI){
    const char *evalS = (*env)->GetStringUTFChars(env, evalS_JNI, 0);

    if (OpenB==1){
       engEvalString(ep, evalS);
       printf("evalSTring %i",OpenB);
    }

    (*env)->ReleaseStringUTFChars(env, evalS_JNI, evalS); // free memory
}

//
// public native void   engOutputBufferNATIVE(String evalS);
//
JNIEXPORT jstring JNICALL Java_JMatLink_engOutputBufferNATIVE  (JNIEnv *env, jobject obj){
   printf("%s", buffer);
   return (*env)->NewStringUTF(env, buffer);
};

//
// public native void   engPutArrayNATIVE(String name, double value)
//
JNIEXPORT void JNICALL Java_JMatLink_engPutArrayNATIVE__Ljava_lang_String_2D
  (JNIEnv *env, jobject obj, jstring matrixS_JNI, jdouble valueD){

    const char *matrixS = (*env)->GetStringUTFChars(env, matrixS_JNI, 0);

    if (OpenB!=0){
       printf("engPutArray %s",matrixS);

       T = mxCreateDoubleMatrix(1, 1, mxREAL);
       mxSetName(T, matrixS);

       TP  = mxGetPr(T);
       *TP = valueD;
       engPutArray(ep, T);
    }

    mxDestroyArray(T);                                        // free memory
    (*env)->ReleaseStringUTFChars(env, matrixS_JNI, matrixS); // free memory
};

//
// public native engPutArrayNATIVE(String nameS, double[] array );
//
JNIEXPORT void JNICALL Java_JMatLink_engPutArrayNATIVE__Ljava_lang_String_2_3D
  (JNIEnv *env, jobject obj, jstring matrixS_JNI, jdoubleArray valueD_JNI){

   const char *matrixS = (*env)->GetStringUTFChars(env, matrixS_JNI, 0);

   double *valueP= (*env)->GetDoubleArrayElements(env, valueD_JNI, 0);
  
   long int length = (*env)->GetArrayLength(env, valueD_JNI);

   int i=0;


   printf("engPutArray [] %s %i", matrixS, length);

   if (OpenB!=0) {
      T = mxCreateDoubleMatrix(1, length, mxREAL);
      mxSetName(T, matrixS);

      TP  = mxGetPr(T);
      for (i=0; i<length; i++) {
         TP[i] = valueP[i];
      }

      engPutArray(ep, T);
   }

   mxDestroyArray(T);                                              // free memory
   (*env)->ReleaseDoubleArrayElements(env, valueD_JNI, valueP, 0); // free memory
   (*env)->ReleaseStringUTFChars(env, matrixS_JNI, matrixS);       // free memory
}


//
// public native engPutArrayNATIVE(String nameS, double[][] array );
//
JNIEXPORT void JNICALL Java_JMatLink_engPutArrayNATIVE__Ljava_lang_String_2_3_3D
   (JNIEnv *env, jobject obj, jstring arrayS_JNI, jobjectArray valueDD_JNI){

    int i, j;
    const char *arrayS    = (*env)->GetStringUTFChars(env, arrayS_JNI, 0);
    int   rowCount        = (*env)->GetArrayLength(env, valueDD_JNI);
    jobject colPtr        = (*env)->GetObjectArrayElement(env, valueDD_JNI, 0);
    int   colCount        = (*env)->GetArrayLength(env, colPtr);
    jboolean *isCopy;
    double *tPtrR;  

    //double *arrayElements = (*env)->GetDoubleArrayElements(env, colPtr, isCopy);
jdouble *arrayElements;

    printf("engPutArray [][] %s %i %i\n", arrayS, rowCount, colCount);

    T = mxCreateDoubleMatrix(rowCount, colCount, mxREAL);
    mxSetName(T, arrayS);
    //printf("matrix created and name set\n");
    tPtrR = mxGetPr(T);

    for (i=0; i<rowCount; i++) {
    //printf("row %i\n",i);
        colPtr = (*env)->GetObjectArrayElement(env, valueDD_JNI, i);
        //printf("got colPtr %i\n",i);
        arrayElements = (*env)->GetDoubleArrayElements(env, colPtr, 0);
        //printf("got array Elements\n");
        for (j=0; j<colCount; j++) {
            //printf("col %i\n",j);
            tPtrR[i + j*rowCount] = arrayElements[j];
        }
    } // rows

    //printf("elements copied\n");
    engPutArray(ep, T);
    mxDestroyArray(T);
   (*env)->ReleaseStringUTFChars(env, arrayS_JNI, arrayS); // free memory
};



//
// public native double      engGetScalarNATIVE(String nameS);
//
JNIEXPORT jdouble JNICALL Java_JMatLink_engGetScalarNATIVE
          (JNIEnv *env, jobject obj, jstring scalarS_JNI){


   const char *scalarS = (*env)->GetStringUTFChars(env, scalarS_JNI, 0);

   printf("native engGetScalar %s \n",scalarS);

   if (OpenB==0) return 0.0; // engine is not open   

   arrayP = engGetArray( ep, scalarS);
   if (arrayP == NULL) {
      printf("Could not get scalar from MATLAB workspace.\n");
      (*env)->ReleaseStringUTFChars(env, scalarS_JNI, scalarS); // free memory
      return 0.0;
   }
   else {
      scalar = mxGetScalar(arrayP);
   }
 	
   mxDestroyArray(arrayP);                                   // free memory
   (*env)->ReleaseStringUTFChars(env, scalarS_JNI, scalarS); // free memory

   return scalar;
}


/*
JNIEXPORT jdoubleArray JNICALL Java_JMatLink_engGetVectorNATIVE
          (JNIEnv *env, jobject obj, jstring vectorS_JNI){
   printf("engGetVector\n");

   jdoubleArray time[10] = { 0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0 };

   return time;
}
*/

//
// public native double[][]  engGetArrayNATIVE(String nameS)
// 
// NOTE: in java there are only 1-dimensional (array[]) arrays.
//       higher dimensional arrays are arrays of arrays.
JNIEXPORT jobjectArray JNICALL Java_JMatLink_engGetArrayNATIVE
          (JNIEnv *env, jobject jThis, jstring arrayS_JNI){

   jarray rowA;
   jclass rowClass;

   jarray columnA;
   int in,im;
   int m = 0;
   int n = 0;
  
   jdouble *rowElements;
   double *TP;

   // convert array name to c-string
   const char *arrayS = (*env)->GetStringUTFChars(env, arrayS_JNI, 0);

  if (OpenB!=0){

   printf("native engGetArray %s \n",arrayS);

   arrayP = engGetArray( ep, arrayS);
   if (arrayP == NULL) {
      printf("Could not get array %s from MATLAB workspace.\n", arrayS);
      (*env)->ReleaseStringUTFChars(env, arrayS_JNI, arrayS); // free memory
      return NULL;
   }

   m  = mxGetM( arrayP );   // rows 
   n  = mxGetN( arrayP );   // columns 
   TP = mxGetPr( arrayP );  // get pointer to values

 
      /* create an array of double and get its class  */
      rowA        = (*env)->NewDoubleArray( env, n);              // row vector
      rowClass    = (*env)->GetObjectClass( env, rowA);           // row class

      /* create an array of object with the rowClass as the
         the default element */
      columnA = (*env)->NewObjectArray( env, m, rowClass, NULL);  // column vector


   for (im=0; im<m; im++) {
      rowA        = (*env)->NewDoubleArray( env, n);              // row vector
      rowClass    = (*env)->GetObjectClass( env, rowA);           // row class
      rowElements = (*env)->GetDoubleArrayElements(env, rowA, 0); // row elements

      for (in=0; in<n; in++) {
         rowElements[in] = TP[in*m + im];  
      }

      (*env)->SetObjectArrayElement(env, columnA, im, rowA);

      (*env)->ReleaseDoubleArrayElements(env, rowA, rowElements, 0);
   }
  } // end OpenB

   mxDestroyArray(arrayP);                                 // free memory
   (*env)->ReleaseStringUTFChars(env, arrayS_JNI, arrayS); // free memory

  if (OpenB==1) return columnA;
  else          return NULL;
}

//
// public String[] engGetCharArrayNATIVE(String name)
// 
JNIEXPORT jobjectArray JNICALL Java_JMatLink_engGetCharArrayNATIVE
   (JNIEnv *env, jobject jthis, jstring arrayS_JNI){

   const char *arrayS = (*env)->GetStringUTFChars(env, arrayS_JNI, 0);

   if (OpenB!=0){

     printf("native engGetArray %s \n",arrayS);

   arrayP = engGetArray( ep, arrayS);
   if (arrayP == NULL) {
      printf("Could not get array %s from MATLAB workspace.\n", arrayS);
      (*env)->ReleaseStringUTFChars(env, arrayS_JNI, arrayS); // free memory
      return NULL;
   }
   if (mxIsChar(arrayP) != 0) {
      printf("The array %s is not of type char.\n", arrayS);
      (*env)->ReleaseStringUTFChars(env, arrayS_JNI, arrayS); // free memory
      return NULL;
   }

   } // end OpenB

   mxDestroyArray(arrayP);                                 // free memory
   (*env)->ReleaseStringUTFChars(env, arrayS_JNI, arrayS); // free memory
} // end engGetCharArrayNATIVE


// 
// public native void HelloWorld(void)
//
JNIEXPORT void JNICALL 
Java_JMatLink_displayHelloWorld(JNIEnv *env, jobject obj) 
{


       printf("Hello world!\n");

	/*
	 * Start the MATLAB engine locally by executing the string
	 * "matlab"
	 *
	 * To start the session on a remote host, use the name of
	 * the host as the string rather than \0
	 *
	 * For more complicated cases, use any string with whitespace,
	 * and that string will be executed literally to start MATLAB
	 */
	if (!(ep = engOpen("\0"))) {
		fprintf(stderr, "\nCan't start MATLAB engine\n");
		return;
	}

	/*
	 * PART I
	 *
	 * For the first half of this demonstration, we will send data
	 * to MATLAB, analyze the data, and plot the result.
	 */

	/* 
	 * Create a variable for our data
	 */
	T = mxCreateDoubleMatrix(1, 10, mxREAL);
	mxSetName(T, "T");
	memcpy((void *)mxGetPr(T), (void *)time, sizeof(time));
	/*
	 * Place the variable T into the MATLAB workspace
	 */
	engPutArray(ep, T);

	/*
	 * Evaluate a function of time, distance = (1/2)g.*t.^2
	 * (g is the acceleration due to gravity)
	 */
	engEvalString(ep, "D = .5.*(-9.8).*T.^2;");

	/*
	 * Plot the result
	 */
	engEvalString(ep, "plot(T,D);");
	engEvalString(ep, "title('Position vs. Time for a falling object');");
	engEvalString(ep, "xlabel('Time (seconds)');");
	engEvalString(ep, "ylabel('Position (meters)');");

	/*
	 * use fgetc() to make sure that we pause long enough to be
	 * able to see the plot
	 */
	printf("Hit return to continue\n\n");
	fgetc(stdin);
	/*
	 * We're done for Part I! Free memory, close MATLAB engine.
	 */
	printf("Done for Part I.\n");
	mxDestroyArray(T);
	engEvalString(ep, "close;");


	/*
	 * PART II
	 *
	 * For the second half of this demonstration, we will request
	 * a MATLAB string, which should define a variable X.  MATLAB
	 * will evaluate the string and create the variable.  We
	 * will then recover the variable, and determine its type.
	 */
	  
	/*
	 * Use engOutputBuffer to capture MATLAB output, so we can
	 * echo it back.
	 */

	engOutputBuffer(ep, buffer, BUFSIZE);
	while (result == NULL) {
	    char str[BUFSIZE];
	    /*
	     * Get a string input from the user
	     */
	    printf("Enter a MATLAB command to evaluate.  This command should\n");
	    printf("create a variable X.  This program will then determine\n");
	    printf("what kind of variable you created.\n");
	    printf("For example: X = 1:5\n");
	    printf(">> ");

	    fgets(str, BUFSIZE-1, stdin);
	  
	    /*
	     * Evaluate input with engEvalString
	     */
	    engEvalString(ep, str);
	    
	    /*
	     * Echo the output from the command.  First two characters are
	     * always the double prompt (>>).
	     */
	    printf("%s", buffer+2);
	    
	    /*
	     * Get result of computation
	     */
	    printf("\nRetrieving X...\n");
	    if ((result = engGetArray(ep,"X")) == NULL)
	      printf("Oops! You didn't create a variable X.\n\n");
	    else {
		printf("X is class %s\t\n", mxGetClassName(result));
	    }
	}

	/*
	 * We're done! Free memory, close MATLAB engine and exit.
	 */
	printf("Done!\n");
	mxDestroyArray(result);
	engClose(ep);
	
    return;
}
